import { RepositoryPort } from '@mobicoop/ddd-library';
import { UsernameEntity } from '../../domain/username.entity';
import { Type } from '../../domain/username.types';

export type UsernameRepositoryPort = RepositoryPort<UsernameEntity> & {
  findByType(userId: string, type: Type): Promise<UsernameEntity>;
  findByName(name: string): Promise<UsernameEntity>;
  updateUsername(oldName: string, entity: UsernameEntity): Promise<void>;
  deleteUsername(entity: UsernameEntity): Promise<boolean>;
  countUsernames(userId: string): Promise<number>;
};
